-------------------------------------------
--- AddOn: ReadySetDing					---
--- Author: Ketho (EU-Boulderfist)		---
--- License: Public Domain				---
-------------------------------------------
--- ReadySetDing	v0.82 [2011.03.14]	---
--- Ace3 Framework	r1009 [2011.02.09]	---
-------------------------------------------
--- AddOn: Curse			http://wow.curse.com/downloads/wow-addons/details/readysetding.aspx
--- AddOn: WoWInterface		http://www.wowinterface.com/downloads/info16220-ReadySetDing.html
--- I don't have any previous programming experience or background in any (scripting) language

-- http://www.wowace.com/addons/ace3/pages/api/ace-addon-3-0/
ReadySetDing = LibStub("AceAddon-3.0"):NewAddon("ReadySetDing", "AceEvent-3.0", "AceTimer-3.0", "AceConsole-3.0")
local RSD = ReadySetDing
local ACR = LibStub("AceConfigRegistry-3.0")
local ACD = LibStub("AceConfigDialog-3.0")

-- http://www.wowace.com/addons/ace3/pages/api/ace-locale-3-0/
local L = LibStub("AceLocale-3.0"):GetLocale("ReadySetDingLocale", true)

	--------------------
	--- 01  UPVALUES ---
	--------------------

local _G = _G -- global table

--# Lua APIs
-- http://www.wowpedia.org/Lua_functions
-- http://www.lua.org/manual/5.1/
local print = print
local pairs, select, type = pairs, select, type
local tonumber, unpack = tonumber, unpack
local floor, mod, random = floor, mod, random  -- math.floor,  math.fmod, math.random
local date, time = date, time -- os.date, os.time (mirrored)
local format, gsub = format, gsub -- string.format, string.gsub
local strlower = strlower -- string.lower
local strfind, strlen, strsub = strfind, strlen, strsub -- string.find, string.len, string.sub
local strjoin, strtrim = strjoin, strtrim -- string.join, string.trim (WoW Lua)
local sort = sort -- table.sort
local tmaxn = table.maxn
local band = bit.band -- BitLib library

--# WoW APIs
-- http://www.wowpedia.org/World_of_Warcraft_API
-- http://wowprogramming.com/docs/api
local SCM = SendChatMessage
local GS = GetStatistic
local PSF = PlaySoundFile
local UnitName = UnitName
local IsInGuild, GuildRoster, GetGuildRosterInfo = IsInGuild, GuildRoster, GetGuildRosterInfo
local IsInInstance, GetRealZoneText = IsInInstance, GetRealZoneText

--# File-local scope variables
local profile, realm, char

local playerDinged

local levelTime
local TPM_totalTime, TPM_currentTime = 0, 0
local TPM_totalTime2, TPM_currentTime2
local timeInstance, timeInstance2 = 0, 0

local lastPlayedRequest, timeLogin = time(), time()
local timeInstanceStart, timeInstanceStart2, timeInstanceEnd
local timeAFK1, timeAFK2

local realZone, instanceType

local randomIcon1, randomIcon2
local soundPath, showedDiffs


-- http://wowprogramming.com/utils/xmlbrowser/live/FrameXML/GlobalStrings.lua
local DEFAULT = DEFAULT

-- http://wowprogramming.com/utils/xmlbrowser/live/FrameXML/Constants.lua
local RAID_CLASS_COLORS = RAID_CLASS_COLORS

-- I don't want the capitalized GlobalStrings (except for German locale)
local D_SECONDS = strlower(D_SECONDS)
local D_MINUTES = strlower(D_MINUTES)
local D_HOURS = strlower(D_HOURS)
local D_DAYS = strlower(D_DAYS)

if GetLocale() == "deDE" then
	D_SECONDS = _G.D_SECONDS
	D_MINUTES = _G.D_MINUTES
	D_HOURS = _G.D_HOURS
	D_DAYS = _G.D_DAYS
end

local bttn = CreateFrame("Button")
local D_MINUTES2 = gsub(D_MINUTES, "%%d", "%%.1f") -- replace decimal integer with float
local HOUR = strreplace(bttn:GetText(bttn:SetFormattedText(_G.D_HOURS, 1)), "1 ", "") -- singular hour

-- http://www.wowpedia.org/UI_escape_sequences
local iconCropped = ":64:64:4:60:4:60"
local RT = "Interface\\TargetingFrame\\UI-RaidTargetingIcon_"
local Main = "ReadySet|cffFFFFFFDing|r  |TInterface\\AddOns\\ReadySetDing\\Images\\Windows7_Logo:22:22:-4:0|t"

-- this string is so damned long it f*cks up my text editor (Notepad++)
local legend
do
	local z1 = "\n|cff58ACFA[QUESTS]|r |cffFFFFFF= "..QUESTS_LABEL.."|r\n|cff58ACFA[ZONE]|r |cffFFFFFF= "..strupper(strsub(SPELL_TARGET_TYPE6_DESC, 1, 1))..strsub(SPELL_TARGET_TYPE6_DESC, 2).."|r\n|cffF6ADC6[LEVEL-]|r |cffFFFFFF= "..L["Previous Level"].."|r\n|cffF6ADC6[LEVEL]|r |cffFFFFFF= "..L["New Level"].."|r\n|cffF6ADC6[REM]|r |cffFFFFFF= "..L["Remaining Levels"].."|r"
	local z2 = "\n|cffF6ADC6[MAX]|r |cffFFFFFF= "..L["Max Level"].."|r\n|cff71D5FF[TIME]|r |cffFFFFFF= "..L["Level Time"].."|r\n|cff71D5FF[TOTAL]|r |cffFFFFFF= "..L["Total Time"].."|r\n|cff71D5FF[DIFF]|r |cffFFFFFF= "..L["Difference"].."|r\n|cff71D5FF[AFK]|r, |cff71D5FF[AFK+]|r |cffFFFFFF= "..L["AFK Time"].."|r"
	local z3 = "\n|cffB6CA00[XP]|r |cffFFFFFF= "..COMBAT_XP_GAIN.." "..SPEED.."|r\n|cffB6CA00[SPEED]|r |cffFFFFFF= "..L["Level Speed"].."|r\n|cffB6CA00[SPEED+]|r |cffFFFFFF= "..L["Average"].." "..L["Level Speed"].."|r\n|cff0070DD[DATE]|r  |cffFFFFFF= MM/DD/YY hh:mm|r\n|cff0070DD[DATE2]|r |cffFFFFFF= YYYY.MM.DD hh:mm|r"
	local z4 = "\n|cffFF0000[KILLS]|r, |cffFF0000[KILLS+]|r |cffFFFFFF= "..L["Kills"].."|r\n|cffFF0000[DEATHS]|r, |cffFF0000[DEATHS+]|r |cffFFFFFF= "..L["Deaths"].."|r\n|cffADFF2F[NAME]|r, |cffADFF2F[CLASS]|r, |cffADFF2F[RACE]|r, |cffADFF2F[GUILD]|r, |cffADFF2F[FACTION]|r, |cffADFF2F[REALM]|r\n"..TARGETICONS..": |cffFFFFFF{Moon} |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_5:12|t|r"
	legend = z1..z2..z3..z4
end

local optionsFrame = {}
local cd = {} -- some table to dump in the cooldowns / throttles

local player = {
	expansion = GetAccountExpansionLevel(),
	realm = GetRealmName(),
	faction = select(2, UnitFactionGroup("player")),
	class = UnitClass("player"),
	race = UnitRace("player"),
	level = UnitLevel("player"),
	name = UnitName("player"),
	XPMax = UnitXPMax("player"),
	maxLevel = 85,
}

local BossIDs = { -- Instance Timer
--	[01-60] Classic
	1853, -- Darkmaster Gandling; Scholomance
	2748, -- Archaedas; Uldaman
	3975, -- Herod; Scarlet Monastery: Armory
	3977, -- High Inquisitor Whitemane; Scarlet Monastery: Cathedral
	3654, -- Mutanus the Devourer; Wailing Caverns
	4275, -- Archmage Arugal; Shadowfang Keep (Normal/Heroic)
	4421, -- Charlga Razorflank; Razorfen Kraul
	4543, -- Bloodmage Thalnos; Scarlet Monastery: Graveyard
	4829, -- Aku'mai; Blackfathom Deeps
	5709, -- Shade of Eranikus; Sunken Temple
	6487, -- Arcanist Doan; Scarlet Monastery: Library
	7267, -- Chief Ukorz Sandscalp; Zul'Farrak
	7358, -- Amnennar the Coldbringer; Razorfen Downs
	7800, -- Mekgineer Thermaplugg; Gnomeregan
	9018, -- High Interrogator Gerstahn; Blackrock Depths: Prison
	9019, -- Emperor Dagran Thaurissan; Blackrock Depths: Upper City
	9568, -- Overlord Wyrmthalak; Lower Blackrock Spire
	10813, -- Balnazzar; Stratholme: Main Gate
	11486, -- Prince Tortheldrin; Dire Maul: Capital Gardens
	11492, -- Alzzin the Wildshaper; Dire Maul: Warpwood Quarter
	11501, -- King Gordok; Dire Maul: Gordok Commons
	11520, -- Taragaman the Hungerer; Ragefire Chasm
	12201, -- Princess Theradras; Maraudon: Earth Song Falls
	12236, -- Lord Vyletongue; Maraudon: The Wicked Grotto
	12258, -- Razorlash; Maraudon: Foulspore Cavern
	45412, -- Lord Aurius Rivendare; Stratholme - Service Entrance
	46964, -- Lord Godfrey; Shadowfang Keep
	46254, -- Hogger; Stormwind Stockade
	47739, -- "Captain" Cookie; Deadmines
	49541, -- Vanessa VanCleef; Deadmines (Heroic)
--	[60-70] The Burning Crusade
	16808, -- Warchief Kargath Bladefist; Hellfire Citadel: The Shattered Halls
	17377, -- Keli'dan the Breaker; Hellfire Citadel: The Blood Furnace
	17536, -- Nazan; Hellfire Citadel: Hellfire Ramparts
	17798, -- Warlord Kalithresh; Coilfang Reservoir: The Steamvault
	17881, -- Aeonus; Caverns of Time: The Black Morass
	17882, -- The Black Stalker; Coilfang Reservoir: The Underbog
	17942, -- Quagmirran; Coilfang Reservoir: The Slave Pens
	17977, -- Warp Splinter; Tempest Keep: The Botanica
	18344, -- Nexus-Prince Shaffar; Auchindoun: Mana-Tombs
	18373, -- Exarch Maladaar; Auchindoun: Auchenai Crypts
	18473, -- Talon King Ikiss; Auchindoun: Sethekk Halls
	18708, -- Murmur; Auchindoun: Shadow Labyrinth
	18096, -- Epoch Hunter; Caverns of Time: Old Hillsbrad Foothills
	19220, -- Pathaleon the Calculator; Tempest Keep: The Mechanar
	20912, -- Harbinger Skyriss; Tempest Keep: The Arcatraz
--	[70-80] Wrath of the Lich King
	26632, -- The Prophet Tharon'ja; Drak'Tharon Keep (name has an extra space at the end when transformed, GUID remains unchanged though)
	26723, -- Keristrasza; The Nexus: The Nexus
	26861, -- King Ymiron; Utgarde Keep: Utgarde Pinnacle
	27656, -- Ley-Guardian Eregos; The Nexus: The Oculus
	27978, -- Sjonnir The Ironshaper; Ulduar: Halls of Stone
	28923, -- Loken; Ulduar: Halls of Lightning
	29120, -- Anub'arak; Azjol-Nerub: Azjol-Nerub
	29306, -- Gal'darah; Gundrak
	29311, -- Herald Volazj; Azjol-Nerub: Ahn'kahet: The Old Kingdom
	31134, -- Cyanigosa; The Violet Hold
	36502, -- Devourer of Souls; Icecrown Citadel: The Forge of Souls
	36658, -- Scourgelord Tyrannus; Icecrown Citadel: Pit of Saron
--	23954, -- Ingvar the Plunderer; Utgarde Keep: Utgarde Pinnacle (dies 2x)
--	26533, -- Mal'Ganis; Caverns of Time: The Culling of Stratholme (no death)
--	35451, -- The Black Knight; Crusaders' Coliseum: Trial of the Champion (dies 3x)
--	36954, -- The Lich King; Icecrown Citadel: Halls of Reflection (no death)
--	[80-85] Cataclysm
	39705, -- Ascendant Lord Obsidius; Blackrock Caverns
	39378, -- Rajh; Halls of Origination
	40484, -- Erudax; Grim Batol
	42333, -- High Priestess Azil; The Stonecore
	43875, -- Asaad; The Vortex Pinnacle
--	44566, -- Ozumat; Throne of the Tides [no death; 1hp]
	44819, -- Siamat; Lost City of the Tol'vir
}

	------------------------------
	--- 02  Options & Defaults ---
	------------------------------

local defaults = {
	profile = {
		dingMessage = {
			L["dingMessage1"],
			L["dingMessage2"],
			L["dingMessage3"],
			L["dingMessage4"],                
			L["dingMessage5"],
			L["dingMessage6"],
		},
		outputFrame = 2,
		screenshotDelay = 1,
		announceDelay = 0,
		customSound = "Interface\\AddOns\\ReadySetDing\\Sounds\\MySound.mp3",
		autoGratzDelay = 0,
		autoGratzCooldown = 60,
		autoGratzMsg = {
			"gz", -- 1
			"{rt1} gz {rt1}", -- 4
			"gz =)", -- 2
			"{rt3} gz {rt3}", -- 5
			"grats", -- 3
			"gratz [NAME]", -- 6
		},
		guildMemberAchievementFilter = true,
		guildMemberLevelFilter = 10,
		guildMemberMsg = L["guildMemberMsg"],
		instanceTimerMsg = L["instanceTimerMsg"],
	},
	char = {
	--	just needed a starting value ... so troublesome
		stats = {
			timeAFK = 0,
			totalAFK = 0,
			kills = 0,
			deaths = 0,
		},
	},
}

-- http://www.wowace.com/addons/ace3/pages/ace-config-3-0-options-tables/
local options = {
	type = "group",
	name = "",
	args = {
		Main = {
			type = "group",
			name = "\124cffADFF2FReadySet\124r|cffFFFFFFDing|r |cffB6CA00v0.82|r", -- Main Options Header
			handler = RSD,
			args = {
				toggleScreenshot = {
					type = "toggle",
					order = 1,
					desc = BINDING_NAME_SCREENSHOT,
					name = "|TInterface\\Icons\\inv_misc_spyglass_03:20:20:1:0"..iconCropped.."|t   "..L["Screenshot"],
					get = function() return profile.Screenshot end,
					set = function(i, v) profile.Screenshot = v end,
					disabled = "OptionsDisabled",
				},
				toggleAutoGratz = {
					type = "toggle",
					order = 3,
					descStyle = "",
					name = "|TInterface\\Icons\\INV_Misc_Gift_05:20:20:1:0"..iconCropped.."|t   "..L["Auto Gratz"],
					get = function(i) return profile.AutoGratz end,
					set = function(i, v) profile.AutoGratz = v end,
					disabled = "OptionsDisabled",
				},
				toggleGuildMemberDings = {
					type = "toggle",
					order = 5,
					descStyle = "",
					name = "|TInterface\\GuildFrame\\GuildLogo-NoLogo:20:20:1:0:64:64:14:51:14:51|t   "..L["Guild Dings"],
					get = function(i) return profile.GuildMemberDings end,
					set = function(i, v) profile.GuildMemberDings = v
						if IsInGuild() then
							if profile.GuildMemberDings then
								RSD.GuildRosterTimer = RSD:ScheduleRepeatingTimer(function() GuildRoster() end, 11)
							else
								RSD:CancelTimer(RSD.GuildRosterTimer)
							end
						end
					end,
					disabled = "OptionsDisabled",
				},
				toggleNormalAnnounce = {
					type = "toggle",
					order = 2,
					descStyle = "",
					name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:20:20:3:0:32:32:2:30:2:30|t   "..L["Normal Announce"],
					get = function(i) return profile.normalAnnounce end,
					set = function(i, v) profile.normalAnnounce = v end,
					disabled = "OptionsDisabled",
				},
				toggleGuildAnnounce = {
					type = "toggle",
					order = 4,
					descStyle = "",
					name = function() return RSD:GuildEmblem()..L["Guild Announce"] end,
					get = function(i) return profile.guildAnnounce end,
					set = function(i, v) profile.guildAnnounce = v end,
					disabled = "OptionsDisabled",
				},
				toggleBNetBroadcast = {
					type = "toggle",
					order = 6,
					desc = BN_BROADCAST_TOOLTIP,
					name = function()
						if time() > (cd.randomIcon1 or 0) then
							cd.randomIcon1 = time() + 120
							local a = random(4)
							if	   a <= 2 then randomIcon1 = "PlusManz-BattleNet" -- \Data\enGB\locale-enGB.MPQ\Interface\FriendsFrame\PlusManz-BattleNet.blp
							elseif a == 3 then randomIcon1 = "Battlenet-WoWicon"
							elseif a == 4 then randomIcon1 = "Battlenet-Sc2icon"
							end
						end
						return "|TInterface\\FriendsFrame\\"..randomIcon1..":24|t  "..L["Real ID Broadcast"]
					end,
					get = function(i) return profile.BNetBroadcast end,
					set = function(i, v) profile.BNetBroadcast = v end,
					disabled = "OptionsDisabled",
				},
				inputDingMessage = {
					type = "input",
					order = 7,
					width = "full",
				--	multiline = true, -- prefer normal one over multiline
					name = " ", -- If it was like "" then usage wouldnt appear
					usage = legend,
					get = function(i) return profile.dingMessage[1] end,
					set = function(i, v) profile.dingMessage[1] = v
						RSD:ValidateMessage(v)
						if #strtrim(v) == 0 then profile.dingMessage[1] = defaults.profile.dingMessage[1] end
					end,
					disabled = function() return not RSD:IsEnabled() or profile.randomMessage end,
				},
				descriptionExample = {
					type = "description",
					order = 8,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[1], "ExampleDingMsg") end,
				},
				header = {type = "header", order = 9, name = ""},
				descriptionLevelSummary = {
					type = "description",
					order = 10,
					name = function() return RSD:LevelSummary() end,
				},
			},
		},
		Advanced = {
			type = "group",
			name = "",
			handler = RSD,
			args = {
				status1 = {
					type = "description",
					order = 1,
					name = function() return not RSD:IsEnabled() and " |cffA8A8FFNormal|r Dings: |cffFF2424Disabled|r" or profile.normalAnnounce and " |cffA8A8FFNormal|r Dings: |cffADFF2FAnnounce|r" or " |cffA8A8FFNormal|r Dings: |cffADFF2FLocal|r" end,
				},
				status2 = {
					type = "description",
					order = 2,
					name = function() return (not RSD:IsEnabled() or not profile.GuildMemberDings) and " |cff40FF40Guild|r Dings: |cffFF2424Disabled|r\n" or profile.guildMemberAnnounce and " |cff40FF40Guild|r Dings: |cffADFF2FAnnounce|r\n" or " |cff40FF40Guild|r Dings: |cffADFF2FLocal|r\n" end,
				},
				selectOutputFrame = {
					type = "select",
					order = 3,
					descStyle = "",
					name = "   Local Output Frame",
					values = function()
						local a, ChatWindows = "|cff71D5FF", {}
						ChatWindows[1] = a.."#|r  UIErrorsFrame"
						ChatWindows[2] = a.."#|r  RaidWarningFrame"
						ChatWindows[3] = a.."#|r  RaidBossEmoteFrame"
						for i = 1, NUM_CHAT_WINDOWS do
							local b = GetChatWindowInfo(i)
							if #b > 0 then
								ChatWindows[i+3] = a..i..".|r "..b
							end
						end
						return ChatWindows
					end,
					get = function(i) return profile.outputFrame end,
					set = function(i, v) profile.outputFrame = v
						RSD:OutputFrame(nil, true)
					end,
					disabled = "OptionsDisabled",
				},
				header01 = {type = "header", order = 4, name = ""},
				toggleScreenshotHideUI = {
					type = "toggle",
					order = 5,
					width = "full",
					descStyle = "",
					name = "|TInterface\\Icons\\INV_Gizmo_GoblingTonkController:20:20:1:1:64:64:4:60:4:60|t  "..L["Screenshot"]..": "..HIDE.." "..BUG_CATEGORY5,
					get = function(i) return profile.screenshotHideUI end,
					set = function(i, v) profile.screenshotHideUI = v end,
					disabled = function() return not RSD:IsEnabled() or not profile.Screenshot end,
				},
				toggleZoneAnnounce = {
					type = "toggle",
					order = 6,
					width = "full",
					descStyle = "",
					name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:20:20:1:0"..iconCropped.."|t  |cffFFACAC"..ZONE.."|r "..CHAT_ANNOUNCE,
					get = function(i) return profile.zoneAnnounce end,
					set = function(i, v) profile.zoneAnnounce = v end,
					disabled = "OptionsDisabled",
				},
				toggleRandomMessage = {
					type = "toggle",
					order = 7,
					width = "full",
					descStyle = "",
					name = "|TInterface\\AddOns\\ReadySetDing\\Images\\Awesome:24:24:-2:1|t Random Messages",
					get = function(i) return profile.randomMessage end,
					set = function(i, v) profile.randomMessage = v
						if v then
							ACD:Open("ReadySetDing_RandomMessage")
							InterfaceOptionsFrame:Hide()
						end
					end,
					disabled = "OptionsDisabled",
				},
				header02 = {type = "header", order = 8, name = ""},
				rangeScreenshotDelay = {
					type = "range",
					order = 9,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 1 "..strlower(SECONDS),
					name = "|TInterface\\Icons\\inv_misc_spyglass_03:18:18:1:0"..iconCropped.."|t  "..L["Screenshot"].." "..L["Delay"],
					get = function(i) return profile.screenshotDelay end,
					set = function(i, v) profile.screenshotDelay = v end,
					min = 0, softMin = 0,
					max = 60, softMax = 2,
					step = 0.1,
					disabled = "OptionsDisabled",
				},
				newline01 = {type = "description", order = 10, name = ""},
				rangeAnnounceDelay = {
					type = "range",
					order = 11,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 0 "..strlower(SECONDS),
					name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:18:18:1:0"..iconCropped.."|t  "..CHAT_ANNOUNCE.." "..L["Delay"],
					get = function(i) return profile.announceDelay end,
					set = function(i, v) profile.announceDelay = v end,
					min = 0, softMin = 0,
					max = 60, softMax = 10,
					step = 0.5,
					disabled = "OptionsDisabled",
				},
				header03 = {type = "header", order = 12, name = ""},
				inputCustomSound = {
					type = "input",
					order = 13,
					width = "full",
					desc = "WoW sound files are also possible",
					name = "   |TInterface\\Icons\\INV_Misc_Bell_01:22:22:0:3"..iconCropped.."|t  Custom |cffFFFFFFDing|r Sound",
					get = function(i) return profile.customSound end,
					set = function(i, v) profile.customSound = v
						if #strtrim(v) == 0 then profile.customSound = defaults.profile.customSound end
					end,
					disabled = "OptionsDisabled",
				},
				executeTestSound = {
					type = "execute",
					order = 14,
					width = "half",
					name = "Test",
					func = function()
					--	would be kinda annoying if some1 accidentally spammed this in combination with long sound files
						if time() > (cd.customSound or 0) then
							cd.customSound = time() + 2
							PlaySoundFile(profile.customSound, "Master")
						end
					end,
					disabled = "OptionsDisabled",
				},
			},
		},
		AutoGratz = {
			type = "group",
			name = "|cffFFFFFF"..L["Auto Gratz"].."|r",
			handler = RSD,
			args = {
				status = {
					type = "description",
					order = 1,
					name = function() return (not RSD:IsEnabled() or not profile.AutoGratz) and " |cffFF2424Disabled|r" or " |cffADFF2FEnabled|r" end,
				},
				toggleGratzAllAchievements = {
					type = "toggle",
					order = 2,
					width = "full",
					descStyle = "",
					name = "|TInterface\\Icons\\Achievement_Reputation_06:20:20:1:1"..iconCropped.."|t  Triggers on all |cffFFFF00"..ACHIEVEMENTS.."|r",
					get = function(i) return profile.gratzAllAchievements end,
					set = function(i, v) profile.gratzAllAchievements = v end,
					disabled = "OptionsDisabled",
				},
				header01 = {type = "header", order = 3, name = ""},
				rangeAutoGratzDelay = {
					type = "range",
					order = 4,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 0 "..strlower(SECONDS).." (|cffFF8000Random|r)",
					name = L["Delay"],
					get = function(i) return profile.autoGratzDelay end,
					set = function(i, v) profile.autoGratzDelay = v end,
					min = 0, softMin = 0,
					max = 60, softMax = 10,
					step = 0.5,
					disabled = "OptionsDisabled",
				},
				newline01 = {type = "description", order = 5, name = ""},
				rangeAutoGratzCooldown = {
					type = "range",
					order = 6,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 60 "..strlower(SECONDS),
					name = L["Cooldown"],
					get = function(i) return profile.autoGratzCooldown end,
					set = function(i, v) profile.autoGratzCooldown = v end,
					min = 0, softMin = 0,
					max = 600, softMax = 120,
					step = 1,
					disabled = "OptionsDisabled",
				},
				header02 = {type = "header", order = 7, name = ""},
				inputAutoGratzMsg1 = {
					type = "input",
					order = 8,
					name = "",
					get = function(i) return profile.autoGratzMsg[1] end,
					set = function(i, v) profile.autoGratzMsg[1] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[1] = defaults.profile.autoGratzMsg[1] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg2 = {
					type = "input",
					order = 9,
					name = "",
					get = function(i) return profile.autoGratzMsg[2] end,
					set = function(i, v) profile.autoGratzMsg[2] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[2] = defaults.profile.autoGratzMsg[2] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg3 = {
					type = "input",
					order = 10,
					descStyle = "",
					name = "",
					get = function(i) return profile.autoGratzMsg[3] end,
					set = function(i, v) profile.autoGratzMsg[3] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[3] = defaults.profile.autoGratzMsg[3] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg4 = {
					type = "input",
					order = 11,
					descStyle = "",
					name = "",
					get = function(i) return profile.autoGratzMsg[4] end,
					set = function(i, v) profile.autoGratzMsg[4] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[4] = defaults.profile.autoGratzMsg[4] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg5 = {
					type = "input",
					order = 12,
					descStyle = "",
					name = "",
					get = function(i) return profile.autoGratzMsg[5] end,
					set = function(i, v) profile.autoGratzMsg[5] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[5] = defaults.profile.autoGratzMsg[5] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg6 = {
					type = "input",
					order = 13,
					descStyle = "",
					name = "",
					get = function(i) return profile.autoGratzMsg[6] end,
					set = function(i, v) profile.autoGratzMsg[6] = v
						if #strtrim(v) == 0 then profile.autoGratzMsg[6] = defaults.profile.autoGratzMsg[6] end end,
					disabled = "OptionsDisabled",
				},
				descriptionRaidTarget = {
					type = "description",
					order = 14,
					fontSize = "medium",
					name = function()
						local t = {}
						for i = 1, 8 do
							t[i] = "  |T"..RT..i..":16:16:0:4|t {rt"..i.."}"
						end
						return strjoin("\n", unpack(t))
					end,
				},
			},
		},
		GuildMemberDings = {
			type = "group",
			name = "|cffFFFFFF"..L["Guild Dings"].."|r",
			handler = RSD,
			args = {
				status = {
					type = "description",
					order = 1,
					name = function() return (not RSD:IsEnabled() or not profile.GuildMemberDings) and " |cffFF2424Disabled|r" or " |cffADFF2FEnabled|r" end,
				},
				toggleGuildMemberAnnounce = {
					type = "toggle",
					order = 2,
					width = "full",
					descStyle = "",
					name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:20:20:1:0"..iconCropped.."|t  "..L["Guild Announce"],
					get = function(i) return profile.guildMemberAnnounce end,
					set = function(i, v) profile.guildMemberAnnounce = v end,
					disabled = function() return (not RSD:IsEnabled() or not profile.GuildMemberDings) end,
				},
				toggleGuildMemberAchievementFiter = {
					type = "toggle",
					order = 3,
					width = "full",
					desc = LEVEL.." |cffB6CA0010|r, |cffB6CA0020|r, |cffB6CA0030|r, ...|r",
					name = function()
						if time() > (cd.randomIcon2 or 0) then
							cd.randomIcon2 = time() + 60
							randomIcon2 = math.random(9)*10
							if randomIcon2 == 90 then randomIcon2 = 85 end
						end
						return "|TInterface\\Icons\\Achievement_Level_"..randomIcon2..":20:20:1:0"..iconCropped.."|t  |cffFFFF00"..ACHIEVEMENTS.."|r "..FILTER
					end,
					get = function(i) return profile.guildMemberAchievementFilter end,
					set = function(i, v) profile.guildMemberAchievementFilter = v end,
					disabled = "OptionsDisabled",
				},
				header01 = {type = "header", order = 4, name = ""},
				rangeGuildMemberFilter = {
					type = "range",
					order = 5,
					desc = "|cffF6ADC6"..DEFAULT.."|r = "..LEVEL.." 10",
					name = "|TInterface\\Icons\\Trade_Engineering:20:20:1:1"..iconCropped.."|t  "..LEVEL.." "..FILTER,
					get = function(i) return profile.guildMemberLevelFilter end,
					set = function(i, v) profile.guildMemberLevelFilter = v end,
					min = 2,
					max = 85,
					step = 1,
					disabled = "OptionsDisabled",
				},
				header02 = {type = "header", order = 6, name = ""},
				inputGuildMemberMsg = {
					type = "input",
					order = 7,
					width = "full",
					name = " ",
					usage = "\n|cff71D5FF[NAME]|r |cffFFFFFF= "..NAME.."|r\n|cffF6ADC6[LEVEL-]|r |cffFFFFFF= "..L["Previous Level"].."|r\n|cffADFF2F[LEVEL] |cffFFFFFF= "..L["New Level"].."|r\n|cff71D5FF[CLASS]|r |cffFFFFFF= "..CLASS.."|r\n|cffADFF2F[RANK]|r |cffFFFFFF= "..RANK.."|r\n|cffF6ADC6[ZONE]|r |cffFFFFFF= "..ZONE.."|r\n|cff71D5FF[TIME]|r |cffFFFFFF=|r |cffF6ADC6RealTime|r\n|cffB6CA00[SPEED]|r |cffFFFFFF= "..L["Level Speed"].."|r",
					get = function(i) return profile.guildMemberMsg end,
					set = function(i, v) profile.guildMemberMsg = v
						if #strtrim(v) == 0 then profile.guildMemberMsg = defaults.profile.guildMemberMsg end
					end,
					disabled = "OptionsDisabled",
				},
				descriptionExample = {
					type = "description",
					order = 8,
					name = function()
						local a = GetNumGuildMembers()
					--	GetNumGuildMembers returns 0 early in the game
						if IsInGuild() and a > 0 then
							local name, rank, _, level, class, zone, _, _, _, _, classFileName = GetGuildRosterInfo(random(a))
							if level == 85 then level = 84 end -- wow .. someone dinged level 86 :)
							return "   "..RSD:ReplaceTextG(profile.guildMemberMsg, true, name, level+1, class, rank, zone, " in "..RSD:TimetoString(random(600, 7200)), " ("..format("%.2f", random(10, 30)/10).." "..HOUR.."/"..LEVEL..")", classFileName)
						else
							return "   |cffF6ADC6"..L["[No Data]"].."|r"
						end
					end,
				},
				description2 = {
					type = "description",
					order = 9,
					name = "\n\n\n\n\n\n  |cff71D5FF[TIME]|r, |cff71D5FF[SPEED]|r = |cffF6ADC6Real world time|r (!)\n\n  Autogratz Example:  \"|cffADFF2Fgz on level |cff71D5FF[LEVEL]|r|cffADFF2F,|r |cff71D5FF[NAME]|r|cffADFF2F!|r\"|r\n\n  |cffFF0000Note:|r Level Speed Ranking is |cffF6ADC6experimental|r,\n  I would like to show it in a Scroll Frame instead + minimum level filter ..",
				},
				GuildMemberLevelSpeed = {
					type = "execute",
					order = 10,
					name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:1:0"..iconCropped.."|t |cffFFFFFF"..L["Level Speed"].."|r",
					func = function()
						local list = {}
						for i = 1, GetNumGuildMembers() do
							local name = GetGuildRosterInfo(i)
							if realm[name] and realm[name][0] then
								list[realm[name][0]] = name
							end
						end
						local i, t = 1, {}
						for k, v in pairs(list) do
							t[i] = k
							i = i + 1
						end
						sort(t)
						for i = 1, #t do
							print("#"..i.." |cff71D5FF"..list[t[i]].."|r |cffADFF2F"..format("%.2f", t[i]).."|r "..HOUR.."/"..LEVEL.." (|cffB6CA00"..realm[list[t[i]]][1].."|r)")
						end
					end,
					disabled = "OptionsDisabled",
				},
			},
		},
		InstanceTimer = {
			type = "group",
			name = "|cffFFFFFF"..L["Instance Timer"].."|r",
			handler = RSD,
			args = {
				status = {
					type = "description",
					order = 1,
					name = function() return  end
				},
				toggleInstanceTimer = {
					type = "toggle",
					order = 2,
					descStyle = "",
					width = "full",
					name = function() local a = (not RSD:IsEnabled() or not profile.instanceTimer) and "|cffFF2424Disabled|r" or "|cffADFF2FEnabled|r" return "|TInterface\\Icons\\Spell_Holy_BorrowedTime:20:20:1:0"..iconCropped.."|t  "..a end,
					get = function(i) return profile.instanceTimer end,
					set = function(i, v) profile.instanceTimer = v end,
					disabled = "OptionsDisabled",
				},
				inputInstanceTimerMsg = {
					type = "input",
					order = 3,
					width = "full",
					name = " ",
					usage = "\n|cff58ACFA[INSTANCE]|r |cffFFFFFF= Instance|r\n|cff71D5FF[TIME]|r |cffFFFFFF= Time|r\n[START]|r |cffFFFFFF= Start Time|r\n|cffADFF2F|cffF6ADC6[END]|r |cffFFFFFF= End Time|r",
					get = function(i) return profile.instanceTimerMsg end,
					set = function(i, v) profile.instanceTimerMsg = v
						if #strtrim(v) == 0 then profile.instanceTimerMsg = defaults.profile.instanceTimerMsg end end,
					disabled = "OptionsDisabled",
				},
				descriptionExample = {
					type = "description",
					order = 4,
					name = function() return "   "..RSD:ReplaceTextI(profile.instanceTimerMsg, nil, true) end,
				},
				description = {
					type = "description",
					order = 5,
					name = "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n",
				},
				executePrintInstanceTimer = {
					type = "execute",
					order = 6,
					descStyle = "",
					name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:1:0"..iconCropped.."|t |cffFFFFFFInstance Data|r",
					func = function()
						if char.timeInstanceList then -- http://forums.wowace.com/showthread.php?p=306562#post306562
							local t, i = {}, 1
							for k, v in pairs(char.timeInstanceList) do
								t[i] = k
								i = i + 1
							end
							sort(t)
							for i = 1, #t do
								print(t[i].." "..char.timeInstanceList[t[i]])
							end
						end
					end,
					disabled = "OptionsDisabled",
				},
			},
		},
		Stats = {
			type = "group",
			name = "",
			handler = RSD,
			args = {
				Experience = {
					type = "description",
					order = 1,
					name = function() return " "..COMBAT_XP_GAIN.." = |cffB6CA00"..UnitXP("player").."|r / |cff71D5FF"..UnitXPMax("player").."|r = |cffADFF2F"..floor((UnitXP("player")/UnitXPMax("player"))*100).."%|r" end,
				},
				LevelDate = {
					type = "description",
					order = 2,
					name = function()
						-- using tmaxn, since here it will include the corresponding level next to it
						-- and then it's possible to rather show the outdated/previous level data, instead of "[No Data]"
						local a = tmaxn(char.dateStampList)
						local b = char.dateStampList[a]
						local c = a > 0 and " "..LEVEL.." |cffB6CA00"..a.."|r: " or " "..LEVEL..": "
						return b and c.."|cff71D5FF"..b.."|r\n" or c.."|cffF6ADC6"..L["[No Data]"].."|r\n"
					end,
				},
				RealTime = {
					type = "description",
					order = 3,
					name = function()
						local a = char.unixTimeList[player.level]
						local b = " "..L["Real Time"].." = "
						return a and b.."|cffB6CA00"..RSD:TimetoString(time()-a).."|r" or b.."|cffF6ADC6"..L["[No Data]"].."|r"
					end,
				},
				LevelTime = {
					type = "description",
					order = 4,
					name = function() return " "..L["Level Time"].." = |cffADFF2F"..RSD:TimetoString(TPM_currentTime+RSD:AddedTime()).."|r" end,
				},
				TotalTime = {
					type = "description",
					order = 5,
					name = function() return " "..L["Total Time"].." = |cff71D5FF"..RSD:TimetoString(TPM_totalTime+RSD:AddedTime()).."|r" end,
				},
				LevelDiff = {
					type = "description",
					order = 6,
					name = function()
						local a = " "..L["Difference"].." = "
						return RSD:TimeDiff(true) == L["[No Data]"] and a.."|cffF6ADC6"..L["[No Data]"].."|r\n" or a.."|cff6495ED"..RSD:TimeDiff(true).."|r\n"
					end,
				},
				XP_Speed = {
					type = "description",
					order = 7,
					name = function() return " "..XP.." "..SPEED.." = |cffADFF2F"..format("%0.f", UnitXP("player")/((TPM_currentTime+RSD:AddedTime())/3600)).."|r "..XP.."/"..HOUR end,
				},
				LevelSpeed = {
					type = "description",
					order = 8,
					name = function()
						local a = " "..L["Level Speed"].." = "
						return RSD:RecentLevelSpeed() == L["[No Data]"] and a.."|cffF6ADC6"..L["[No Data]"].."|r" or a.."|cffB6CA00"..format("%.2f", RSD:RecentLevelSpeed()/3600).."|r "..HOUR.."/"..LEVEL
					end,
				},
				LevelSpeed_Avg = {
					type = "description",
					order = 9,
					name = function()
						local a = " "..L["Average"].." "..L["Level Speed"].." = "
						return player.level > 1 and a.."|cff71D5FF"..format("%.2f", ((TPM_totalTime+RSD:AddedTime())/3600)/(player.level-1)).."|r "..HOUR.."/"..LEVEL.."\n" or a.."|cffF6ADC6"..L["[No Data]"].."|r\n"
					end,
				},
				Activity = {
					type = "description",
					order = 10,
					name = function()
						local a = char.unixTimeList[player.level]
						local b = " "..L["Activity"].." = "
						return a and b.."|cffB6CA00"..format("%.0f%%", ((TPM_currentTime+RSD:AddedTime())/(time()-a))*100).."|r" or b.."|cffF6ADC6"..L["[No Data]"].."|r"
					end,
				},
				Activity_Avg = {
					type = "description",
					order = 11,
					name = function()
						local a = char.unixTimeList[1] or char.unixTimeList[2]
						local b = " "..L["Average"].." "..L["Activity"].." = "
						return a and b.."|cff71D5FF"..format("%.0f%%", ((TPM_totalTime+RSD:AddedTime())/(time()-a))*100) .."|r\n" or b.."|cffF6ADC6"..L["[No Data]"].."|r\n"
					end,
				},
				TimeAFK = {
					type = "description",
					order = 12,
					name = function() return " "..L["AFK Time"].." = |cffB6CA00"..RSD:TimetoString(char.stats.timeAFK).."|r" end,
				},
				TimeAFK_Avg = {
					type = "description",
					order = 13,
					name = function() return " "..L["Total AFK Time"].." = |cff71D5FF"..RSD:TimetoString(char.stats.totalAFK).."|r\n" end,
				},
				Quests = {
					type = "description",
					order = 14,
					name = function()
						local quests, daily = RSD:AchievementStatistics("quests")
						return " "..PLAYER_DIFFICULTY1.." "..QUESTS_LABEL.." = |cffADFF2F"..quests.."|r, "..DAILY.." "..QUESTS_LABEL.." = |cff6495ED"..daily.."|r"
					end,
				},
				Kills = {
					type = "description",
					order = 15,
					name = function() return " "..L["Kills"].." = |cffB6CA00"..char.stats.kills.."|r, "..L["Total Kills"].." = |cff71D5FF"..RSD:AchievementStatistics("kills").."|r" end,
				},
				Deaths = {
					type = "description",
					order = 16,
					name = function() return " "..L["Deaths"].." = |cffFF0000"..char.stats.deaths.."|r, "..L["Total Deaths"].." = |cffFF0000"..RSD:AchievementStatistics("deaths").."|r" end,
				},
				header = {
					type = "header",
					order = 17,
					name = "",
				},
				PrintLevelData = {
					type = "execute",
					order = 18,
					name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:1:0"..iconCropped.."|t |cffFFFFFFLevel Data|r",
					func = function()
						for i = 2, player.maxLevel do
							local a = char.levelTimeList[i]
							local _ = a and print(LEVEL.." |cffF6ADC6"..i-1 .."|r - |cff71D5FF"..i.."|r: |cffB6CA00"..RSD:TimetoString(a).."|r   "..L["Total"]..": |cff71D5FF"..RSD:TimetoString(char.totalTimeList[i]).."|r")
						end
					end,
					disabled = "OptionsDisabled",
				},
				newline01 = {type = "description", order = 19, name = ""},
				ExportData = {
					type = "execute",
					order = 20,
					name = "|TInterface\\Icons\\Trade_Engineering:18:18:1:0"..iconCropped.."|t |cffFFFFFFExport|r",
					func = function() RSD:ExportData() end,
					disabled = "OptionsDisabled",
				},
				newline02 = {type = "description", order = 21, name = ""},
				PlaySound = {
					type = "execute",
					order = 22,
					desc = "|cffADFF2Fboosts e-peen|r",
					name = "|TSPELLS\\HOLIDAYS\\Heart:18|t |cffF6ADC6Play Sound|r", -- ...\Data\common.MPQ\SPELLS\HOLIDAYS\Heart.blp
					func = function()
						if time() > (cd.playSound or 0) then
							cd.playSound = time() + 3
							local descInterface = " /run |cffB6CA00PlaySoundFile(\"Sound\\\\Interface\\\\|r|cff71D5FF"
							local descSpell = " /run |cffB6CA00PlaySoundFile(\"Sound\\\\Spells\\\\|r|cff71D5FF"
							local descEnd = "|r|cffB6CA00.ogg\")|r\n"
							local a = random(10)

							if a <= 2 then PSF("Sound\\Interface\\LevelUp.ogg", "Master"); soundPath = descInterface.."LevelUp"..descEnd -- ...\Data\sound.MPQ\Sound\Interface\LevelUp.ogg -- Player Leveled Up
							elseif a == 3 or a == 4 then PSF("Sound\\Interface\\iQuestComplete.ogg", "Master"); soundPath = descInterface.."iQuestComplete"..descEnd -- ...\Data\sound.MPQ\Sound\Interface\iQuestComplete.ogg -- Quest Comepleted
							elseif a == 5 or a == 6 then PSF("Sound\\Spells\\AchievmentSound1.ogg", "Master"); soundPath = descSpell.."AchievmentSound1"..descEnd -- ...\Data\sound.MPQ\Sound\Spells\AchievmentSound1.ogg -- Achievement Gained
							elseif a == 7 or a == 8 then PSF("Sound\\Spells\\Resurrection.ogg", "Master"); soundPath = descSpell.."Resurrection"..descEnd -- ...\Data\sound.MPQ\Sound\Spells\Resurrection.ogg -- Resurrection
							elseif a == 9 then PSF("Sound\\Creature\\Paletress\\AC_Paletress_Death01.ogg", "Master"); soundPath = " /run |cffB6CA00PlaySoundFile(\"Sound\\\\Creature\\\\Paletress\\\\|r|cff71D5FFAC_Paletress_Death01"..descEnd -- lol
							elseif a == 10 then PSF("Sound\\Character\\BloodElf\\BloodElfFemaleFlirt02.ogg", "Master"); soundPath = " /run |cffB6CA00PlaySoundFile(\"Sound\\\\Character\\\\BloodElf\\\\|r|cff71D5FFBloodElfFemaleFlirt02"..descEnd
							end
						end
					end,
					disabled = "OptionsDisabled",
				},
				SoundPath = {
					type = "description",
					order = 23,
					name = function() -- Sound File Path
						-- yes i'm a micro$oft fanboi .. Windows 7 FTW! .. Tux must die
						local win7 = " |TInterface\\AddOns\\ReadySetDing\\Images\\ReadySet7:32:128:390:135|t"
						if time() < (cd.playSound or 0) then
							return soundPath..win7
						else
							return "\n"..win7
						end
					end,
				},
			},
		},
		RandomMessage = {
			type = "group",
			name = "|TInterface\\AddOns\\ReadySetDing\\Images\\Awesome:24:24:0:5|t  Random Messages",
			handler = RSD,
			args = {
				input1 = {
					type = "input",
					order = 1,
					width = "full",
					name = "  Note: This part is kinda experimental, I'm a noob with frames / AceGUI ...",
					usage = legend,
					get = function(i) return profile.dingMessage[2] end,
					set = function(i, v) profile.dingMessage[2] = v
						if #strtrim(v) == 0 then profile.dingMessage[2] = defaults.profile.dingMessage[2] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description1 = {
					type = "description",
					order = 2,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[2], true) end,
				},
				input2 = {
					type = "input",
					order = 3,
					width = "full",
					name = " ",
					usage = legend,
					get = function(i) return profile.dingMessage[3] end,
					set = function(i, v) profile.dingMessage[3] = v
						if #strtrim(v) == 0 then profile.dingMessage[3] = defaults.profile.dingMessage[3] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description2 = {
					type = "description",
					order = 4,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[3], true) end,
				},
				input3 = {
					type = "input",
					order = 5,
					width = "full",
					name = " ",
					usage = legend,
					get = function(i) return profile.dingMessage[4] end,
					set = function(i, v) profile.dingMessage[4] = v
						if #strtrim(v) == 0 then profile.dingMessage[4] = defaults.profile.dingMessage[4] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description3 = {
					type = "description",
					order = 6,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[4], true) end,
				},
				input4 = {
					type = "input",
					order = 7,
					width = "full",
					name = " ",
					usage = legend,
					get = function(i) return profile.dingMessage[5] end,
					set = function(i, v) profile.dingMessage[5] = v
						if #strtrim(v) == 0 then profile.dingMessage[5] = defaults.profile.dingMessage[5] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description4 = {
					type = "description",
					order = 8,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[5], true) end,
				},
				input5 = {
					type = "input",
					order = 9,
					width = "full",
					name = " ",
					usage = legend,
					get = function(i) return profile.dingMessage[6] end,
					set = function(i, v) profile.dingMessage[6] = v
						if #strtrim(v) == 0 then profile.dingMessage[6] = defaults.profile.dingMessage[6] end
						RSD:ValidateMessage(v)
					end,
					disabled = "OptionsDisabled",
				},
				description5 = {
					type = "description",
					order = 10,
					name = function() return "   "..RSD:ReplaceText(profile.dingMessage[6], true) end,
				},
			},
		},
	},
}

	----------------------------------------------
	---- 03  OnInitialize, OnEnable, OnDisable ---
	----------------------------------------------

function RSD:OnInitialize()

	-- http://www.wowace.com/addons/ace3/pages/api/ace-db-3-0/
	self.db = LibStub("AceDB-3.0"):New("ReadySetDingDB", defaults, true)

	-- not sure anymore if table reference shortcuts can be mixed with the AceDB magic ...
	-- http://old.wowace.com/wiki/Coding_Tips#Cost_of_table_lookup
	profile, realm, char = self.db.profile, self.db.realm, self.db.char
	
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")

	self.db.global.version = 0.82
	self.db.global.fileType = "Release"

	-- http://www.wowace.com/addons/ace3/pages/api/ace-config-registry-3-0/
	ACR:RegisterOptionsTable("ReadySetDing_Main", options.args.Main)
	ACR:RegisterOptionsTable("ReadySetDing_Screenshot", options.args.Advanced)
	ACR:RegisterOptionsTable("ReadySetDing_AutoGratz", options.args.AutoGratz)
	ACR:RegisterOptionsTable("ReadySetDing_GuildMemberDings", options.args.GuildMemberDings)
	ACR:RegisterOptionsTable("ReadySetDing_InstanceTimer", options.args.InstanceTimer)
	ACR:RegisterOptionsTable("ReadySetDing_Stats", options.args.Stats)
	ACR:RegisterOptionsTable("ReadySetDing_RandomMessage", options.args.RandomMessage)

	-- http://www.wowace.com/addons/ace3/pages/api/ace-dboptions-3-0/
	options.args.Profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	ACR:RegisterOptionsTable("ReadySetDing_Profiles", options.args.Profiles)

	-- http://www.wowace.com/addons/ace3/pages/api/ace-config-dialog-3-0/
	optionsFrame.Main = ACD:AddToBlizOptions("ReadySetDing_Main", Main)
	optionsFrame.Advanced = ACD:AddToBlizOptions("ReadySetDing_Screenshot", "|TInterface\\Icons\\Trade_Engineering:18:18:1:0"..iconCropped.."|t  "..ADVANCED_LABEL, Main)
	optionsFrame.AutoGratz = ACD:AddToBlizOptions("ReadySetDing_AutoGratz", "|TInterface\\Icons\\INV_Misc_Gift_05:18:18:1:0"..iconCropped.."|t  "..L["Auto Gratz"], Main)
	optionsFrame.GuildMemberDings = ACD:AddToBlizOptions("ReadySetDing_GuildMemberDings", "|TInterface\\GuildFrame\\GuildLogo-NoLogo:18:18:1:0:64:64:14:51:14:51|t  "..L["Guild Dings"], Main)
	optionsFrame.InstanceTimer = ACD:AddToBlizOptions("ReadySetDing_InstanceTimer", "|TInterface\\Icons\\Spell_Holy_BorrowedTime:18:18:1:0"..iconCropped.."|t  "..L["Instance Timer"], Main)
	optionsFrame.Stats = ACD:AddToBlizOptions("ReadySetDing_Stats", "|TInterface\\Icons\\INV_Misc_QuestionMark:18:18:1:0"..iconCropped.."|t  "..L["Stats"], Main)
	optionsFrame.Profiles = ACD:AddToBlizOptions("ReadySetDing_Profiles", "|TInterface\\Icons\\INV_Misc_Note_01:18:18:1:0"..iconCropped.."|t  "..L["Profiles"], Main)

	-- http://www.wowace.com/addons/ace3/pages/api/ace-console-3-0/
	self:RegisterChatCommand("rsd", "SlashCommand")
	self:RegisterChatCommand("readyset", "SlashCommand")
	self:RegisterChatCommand("readysetding", "SlashCommand")

	-- Define AceDB saved variables if not yet defined
	-- need full table reference patchs, because of all the tables being destroyed by AceDB:ResetDB()
	char.levelTimeList = char.levelTimeList or {}
	char.totalTimeList = char.totalTimeList or {}
	char.experienceList = char.experienceList or {}
	char.unixTimeList = char.unixTimeList or {}
	char.dateStampList = char.dateStampList or {}
	char.activityList = char.activityList or {}
	char.timeInstanceList = char.timeInstanceList or {}
	char.levelSummary = char.levelSummary or {}
end

function RSD:OnEnable()

	-- http://www.wowace.com/addons/ace3/pages/api/ace-event-3-0/
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("TIME_PLAYED_MSG")

	-- Guild Member Dings
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	
	-- Instance Timer, Kills, Deaths
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE")
	self:RegisterEvent("LFG_PROPOSAL_SUCCEEDED")
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL")
	
	-- Auto Gratz
	self:RegisterEvent("CHAT_MSG_PARTY")
	self:RegisterEvent("CHAT_MSG_GUILD")
	self:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
	
	-- AFK Time / Instance Timer Reset
	self:RegisterEvent("CHAT_MSG_SYSTEM")
	self:RegisterEvent("PLAYER_LEAVING_WORLD")

	-- http://www.wowace.com/addons/ace3/pages/api/ace-timer-3-0/
	-- wait (7 sec) for other AddOns first that want to request /played
	self:ScheduleTimer(function()
		if TPM_totalTime == 0 then
			RequestTimePlayed()
		end
	end, 7) -- 777!

	-- refresh Guild Roster with repeating AceTimer
	-- server side throttle on GuildRoster() is 10 seconds*
	if self.db.profile.GuildMemberDings then
		self.GuildRosterTimer = self:ScheduleRepeatingTimer(function() GuildRoster() end, 11)
	end
	
	-- level 1 data
	if player.level == 1 then
		char.unixTimeList[1] = char.unixTimeList[1] or time()
		char.dateStampList[1] = char.dateStampList[1] or date("%Y.%m.%d %H:%M:%S")
	end
end

function RSD:OnDisable()
	self:UnregisterAllEvents()
	self:CancelAllTimers()
end

	------------------------------
	--- 04  Callback Functions ---
	------------------------------
	
-- AceDB profile changes destroy my table reference lookup shortcuts :(
function RSD:RefreshConfig()
	profile, realm, char = self.db.profile, self.db.realm, self.db.char
end

-- gray out options when AddOn disabled
function RSD:OptionsDisabled()
	return not self:IsEnabled()
end

-- refresh all menus
function RSD:NotifyChange()
	ACR:NotifyChange("ReadySetDing_Main")
	ACR:NotifyChange("ReadySetDing_Screenshot")
	ACR:NotifyChange("ReadySetDing_AutoGratz")
	ACR:NotifyChange("ReadySetDing_GuildMemberDings")
	ACR:NotifyChange("ReadySetDing_InstanceTimer")
	ACR:NotifyChange("ReadySetDing_Stats")
end

function RSD:SlashCommand(input)

	if #strtrim(input) == 0 then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.Main)
		-- automatically expand the InterfaceOptionsFrame options by simulating a mouseclick
		for i = 1, #InterfaceOptionsFrameAddOns.buttons do
			if _G["InterfaceOptionsFrameAddOnsButton"..i]:GetText() == Main and optionsFrame.Main.collapsed then
				_G["InterfaceOptionsFrameAddOnsButton"..i.."Toggle"]:Click()
			end
		end

	elseif input == "enable" or input =="on" then
		if not self:IsEnabled() then
			self:Print("|cffADFF2FEnabled|r")
			self:Enable()
		end
		self:NotifyChange()

	elseif input == "disable" or input == "off" then
		if self:IsEnabled() then
			self:Print("|cffFF2424Disabled|r")
			self:Disable()
		end
		self:NotifyChange()

	-- dunno if someone would actually, if ever, use these shortcuts ..
	elseif input == "advanced" or input == "adv" or input == "ad" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.Advanced)
	elseif input == "autogratz" or input == "gratz" or input == "grats" or input == "gz" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.AutoGratz)
	elseif input == "guilddings" or input == "guild" or input == "dings" or input == "ding" or input == "di" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.GuildMemberDings)
	elseif input == "instancetimer" or input == "instance" or input == "inst" or input == "in" or input == "timer" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.InstanceTimer)
	elseif input == "stats" or input == "stat" or input == "st" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.Stats)
	elseif input == "profiles" or input == "prof" or input == "pr" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.Profiles)
		
	elseif input == "export" or input == "exp" or input == "xp" then
		self:ExportData(true)

	else
		print("/rsd |cffADFF2Fon|r: Enable AddOn\n/rsd |cffFF2424off|r: Disable AddOn\n/rsd |cffFFFF00advanced|r: Open Advanced\n/rsd |cffFFFF00gratz|r: Open AutoGratz\n/rsd |cffFFFF00guild|r: Open Guild Dings\n/rsd |cffFFFF00instance|r: Open Instance Timer\n/rsd |cffFFFF00stats|r: Open Stats\n/rsd |cffFFFF00profiles|r: Open Profiles\n/rsd |cff71D5FFexport|r: Export to |cffFFFF00"..SLASH_SAY2.."|r (|cffFF2424SPAM!|r)")
	end
end

function RSD:GuildEmblem()
	if GuildFrameTabardEmblem then
		-- creating new tables = bad, i think. it gets GC'ed right? dont know how to do it without the table
		char.guildTexCoord = {GuildFrameTabardEmblem:GetTexCoord()}
	end
	if IsInGuild() and char.guildTexCoord then
		-- http://www.wowpedia.org/API_Texture_SetTexCoord
		return "|TInterface\\GuildFrame\\GuildEmblemsLG_01:32:32:-5:1:32:32:"..(char.guildTexCoord[1]*32)..":"..(char.guildTexCoord[7]*32)..":"..(char.guildTexCoord[2]*32)..":"..(char.guildTexCoord[8]*32).."|t"
	else
		return "|TInterface\\GuildFrame\\GuildLogo-NoLogo:32:32:-5:1|t"
	end
end

function RSD:TimetoString(value, fullString)
	local seconds = mod(floor(value), 60)
	local minutes = mod(floor(value/60), 60)
	local hours = mod(floor(value/3600), 24)
	local days = floor(value/86400)
	
--	use some Button to get rid of the pipe characters (|)
--	of the "grammar" UI escape sequences Global Strings
--	so that they can be used in SendChatMessage()
	local f_seconds = bttn:GetText(bttn:SetFormattedText(D_SECONDS, seconds))
	local f_minutes = bttn:GetText(bttn:SetFormattedText(D_MINUTES, minutes))
	local f_hours = bttn:GetText(bttn:SetFormattedText(D_HOURS, hours))
	local f_days = bttn:GetText(bttn:SetFormattedText(D_DAYS, days))

	if value >= 0 and value < 60 then
		return f_seconds
	elseif value >= 60 and value < 3600 then
	--	need the .0 / fullstring for a more consistent level summary
		if seconds >= 6 or fullString then
			return bttn:GetText(bttn:SetFormattedText(D_MINUTES2, tonumber(minutes.."."..format("%.0f",floor(seconds/6)))))
		else
			return f_minutes
		end
	elseif value >= 3600 and value < 86400 then
		if minutes > 0 or fullString then
			return f_hours..", "..f_minutes
		else
			return f_hours
		end
	elseif value >= 86400 then
		if hours > 0 or fullString then
			return f_days..", "..f_hours
		else
			return f_days
		end
	end
end

function RSD:AddedTime()
	return time() - lastPlayedRequest
end

function RSD:TimeDiff(example)
	local timeDiff = 0
	local color1A, color1B, escape
	if char.levelTimeList[player.level] then
		if example then
			timeDiff = char.levelTimeList[player.level] - (TPM_currentTime+self:AddedTime())
			color1A, color1B, escape = "|cffF6ADC6", "|cffADFF2F", "|r"
		else
			local a = char.levelTimeList[player.level-1]
			if a then
				timeDiff = a - char.levelTimeList[player.level]
			end
			color1A, color1B, escape = "", "", ""
		end
	end
	return timeDiff < 0 and self:TimetoString(-timeDiff).." "..color1A..L["slower"]..escape or timeDiff > 0 and self:TimetoString(timeDiff).." "..color1B..L["faster"]..escape or L["[No Data]"]
end

-- update [AFK]
local function TimeAFK()
	local stats = RSD.db.char.stats
	timeAFK2 = time()
	stats.timeAFK = stats.timeAFK + (timeAFK2-timeAFK1)
	stats.totalAFK = stats.totalAFK + (timeAFK2-timeAFK1)
end

function RSD:LevelSummary()
	local level = player.level
	if char.levelTimeList[level] and char.levelCounter then
		char.levelSummary[char.levelCounter] = " "..LEVEL.." |cffF6ADC6"..level-1 .."|r - |cff71D5FF"..level.."|r:  |cffB6CA00"..self:TimetoString(char.levelTimeList[level], true).."|r        "..L["Total"]..":  |cff71D5FF"..self:TimetoString(char.totalTimeList[level], true).."|r"
	end
	return strjoin("\n", unpack(char.levelSummary))
end

-- maybe generally a bit more efficient, when player.maxLevel is according to expansion level
-- this function feels a bit ugly though ..
local function ExpansionLimit()
	local nextLevel = player.level + 1
	if	   player.expansion == 3 and player.level < 85 then player.maxLevel = 85 -- Cataclysm
	elseif player.expansion == 2 and player.level < 80 then player.maxLevel = 80 -- Wrath of the Lich King
	elseif player.expansion == 1 and player.level < 70 then player.maxLevel = 70 -- The Burning Crusade
	elseif player.expansion == 0 and player.level < 60 then player.maxLevel = 60 -- Classic / Vanilla
	else nextLevel = "[Max Level]"
	end
	return nextLevel
end

-- [SPEED]; look for a 3 or smaller level difference
function RSD:RecentLevelSpeed()
	local a = char.levelTimeList
	for i = 3, 1, -1 do
		if a[player.level-i] then
			return ((a[player.level-i] + (TPM_totalTime-char.totalTimeList[player.level-i])) + self:AddedTime()) / (i+1)
		end
	end
	return a[player.level] and (a[player.level] + TPM_currentTime + self:AddedTime()) or L["[No Data]"]
end

local function RandomAutoGratzMsg()
	return RSD.db.profile.autoGratzMsg[random(6)]
end

local function RandomAutoGratzDelay()
	return RSD.db.profile.autoGratzDelay == 0 and random(20, 70) / 10 or RSD.db.profile.autoGratzDelay
end

local function GetClassColor(class)
	return format("%02X%02X%02X", RAID_CLASS_COLORS[class].r*255, RAID_CLASS_COLORS[class].g*255, RAID_CLASS_COLORS[class].b*255)
end

function RSD:OutputFrame(msg, example)
	if profile.outputFrame == 1 then
		if example then msg = "UIErrorsFrame" end
		UIErrorsFrame:AddMessage(msg)
	elseif profile.outputFrame ==  2 then
		if example then msg = "RaidWarningFrame" end
		RaidNotice_AddMessage(RaidWarningFrame, msg, {r=1, g=1, b=1})
	elseif profile.outputFrame ==  3 then
		if example then msg = "RaidBossEmoteFrame" end
		RaidNotice_AddMessage(RaidBossEmoteFrame, msg, {r=1, g=1, b=1})
	else
		for i = 1, NUM_CHAT_WINDOWS do
			if example then msg = "RSD: |cff71D5FF"..i..". "..GetChatWindowInfo(i).."|r" end
			if i == profile.outputFrame-3 then
				_G["ChatFrame"..i]:AddMessage(msg)
			end
		end
	end
end

function RSD:AutoGratz(msgType, name)
	self:ScheduleTimer(function() SCM(gsub(RandomAutoGratzMsg(), "%[[Nn][Aa][Mm][Ee]%]", name), msgType) end, RandomAutoGratzDelay())
end

function RSD:InstanceAnnounce(subZone)
	SCM(self:ReplaceTextI(profile.instanceTimerMsg, subZone), GetNumPartyMembers() > 0 and "PARTY" or "SAY")
end

-- Save Instance Timer data to array
function RSD:RecordInstance(subZone)
	subZone = subZone and ": "..subZone.."]" or "]"
	local party = {}
	for i = 1, 4 do
		party[i] = UnitName("party"..i)
	end
	char.timeInstanceList[timeInstanceStart2.."-|cff71D5FF["..date("%H:%M").."]|r"] = "|cffADFF2F["..realZone..subZone.."|r in |cff71D5FF"..self:TimetoString(time() - timeInstance)..".|r "..strjoin(", ", unpack(party))
end

-- http://www.wowhead.com/achievements=2
-- GetStatistic(AchievementID) returns a string type, but it will be "coerced" to a number type, I guess
function RSD:AchievementStatistics(info)
	local questsTotal, questsDaily, totalKills, totalDeaths

	if info == "quests" then
		if GS(98) == "--" then questsTotal = 0 else questsTotal = GS(98) end -- 98 = Quests completed
		if GS(97) == "--" then questsDaily = 0 else questsDaily = GS(97) end -- 97 = Daily quests completed
		-- Quests Completed(Achievement) = Quests completed(Statistic) - Daily quests completed(Statistic); thank you aldon@wowhead
		return questsTotal - questsDaily, questsDaily
	elseif info == "kills" then
		if GS(1197) == "--" then totalKills = 0 else totalKills = GS(1197) end -- 1197 = Total kills
		return totalKills
	elseif info == "deaths" then
		if GS(60) == "--" then totalDeaths = 0 else totalDeaths = GS(60) end -- 60 = Total Deaths
		return totalDeaths
	end
end

-- export level data to print/say (without spamming the server)
function RSD:ExportData(exportSay)
	local export
--	maybe I should learn how to sing the alphabet song ..
	local a, b, c, d, e -- delay
	local k, l, m, n -- coloring for print
	local q, r, s, t, u -- showed data type

--	why is there a throttle here anyway ... button bashers? spammers? xD
--	at least this will make sure LoggingChat() will be correctly set to it's previous value
	if time() > (cd.export or 0) then
		cd.export = time() + 17

		if exportSay then
			a, b, c, d, e = 0, 4, 8, 12, 16
			k, l, m, n = "", "", "", ""
			export = SCM

			local isLogging = LoggingChat()
			LoggingChat(true)

			self:ScheduleTimer(function() LoggingChat(isLogging) if q or r or s or t or u then self:Print("Logged Data to |cff71D5FF..\\Logs\\WoWChatLog.txt|r") end end, 17)

		else
			a, b, c, d, e = 0, 0.5, 1, 1.5, 2.0
			k, l, m, n = "|cffF6ADC6", "|cffB6CA00", "|cff71D5FF", "|r"
			export = print
		end

		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				if char.levelTimeList[i] then
					if not q then export("# "..L["Level Time"]); q = true end
					export(k..i-1 ..n.."-"..l..i..n..": "..m..char.levelTimeList[i]..n)
				end
			end
		end, a)
		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				if char.totalTimeList[i] then
					if not r then export("# "..L["Total Time"]); r = true end
					export(k.. 1 ..n.."-"..l..i..n..": "..m..char.totalTimeList[i]..n)
				end
			end
		end, b)
		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				if char.experienceList[i] then
					if not s then export("# "..XP.."/"..HOUR); s = true end
					export(k..i-1 ..n.."-"..l..i..n..": "..m..char.experienceList[i]..n)
				end
			end
		end, c)
		self:ScheduleTimer(function()
			for i = 1, player.maxLevel do
				if char.dateStampList[i] then
					if not t then export("# "..L["Timestamp"]); t = true end
					export(l..i..n..": "..m..char.dateStampList[i]..n)
				end
			end
		end, d)
		self:ScheduleTimer(function()
			for i = 1, player.maxLevel do
				if char.unixTimeList[i] then
					if not u then export("# Unix "..L["Timestamp"]); u = true end
					export(l..i..n..": "..m..char.unixTimeList[i]..n)
				end
			end
		end, e)
	end
end

function RSD:ValidateMessage(msg)
--	my patterns. just. suck. ><
	local msg = gsub(self:ReplaceText(msg, true), "|r", "")
	msg = gsub(msg, "|cff......", "")
	msg = gsub(msg, "|T.-|t", "") -- this 1 completely removes the (raid target) texture ><

--	show an error if message length exceeds 127 or 255 chars
	local a = strlen(msg)
	if a > 127 and profile.BNetBroadcast then
		print("RSD: |cff71D5FFReal ID|r |cffFF0000Message > 127 chars|r|r ("..a..")")
	end
	if a > 255 then
		print("RSD: |cffFF0000Message > 255 chars|r ("..a..")")
	end
end

function RSD:ReplaceText(msg, isExample)
	local gsub = gsub

--	** massive great wall of gsubs instantly crits you for a ludicrous amount of antimatter dmg **
-- 	** your computer gets struck by a coronal loop .. unless you're happily reading this in the year 2014 .. **

	if isExample then
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", "|cffF6ADC6"..player.level.."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", "|cffF6ADC6"..ExpansionLimit().."|r")
		msg = gsub(msg, "%[[Rr][Ee][Mm]%]", "|cffF6ADC6"..player.maxLevel - (player.level+1).."|r")
		msg = gsub(msg, "%[[Mm][Aa][Xx]]", "|cffF6ADC6"..player.maxLevel.."|r")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", "|cff71D5FF"..self:TimetoString(TPM_currentTime+self:AddedTime()).."|r")
		msg = gsub(msg, "%[[Tt][Oo][Tt][Aa][Ll]%]", "|cff71D5FF"..self:TimetoString(TPM_totalTime+self:AddedTime()).."|r")
		msg = gsub(msg, "%[[Dd][Ii][Ff][Ff]%]", "|cff71D5FF"..self:TimeDiff(true).."|r")
		msg = gsub(msg, "%[[Aa][Ff][Kk]%]", "|cff71D5FF"..self:TimetoString(char.stats.timeAFK).."|r")
		msg = gsub(msg, "%[[Aa][Ff][Kk]%+%]", "|cff71D5FF"..self:TimetoString(char.stats.totalAFK).."|r")
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]%]", "|cff0070DD"..date("%m/%d/%y %H:%M").."|r")
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]2%]", "|cff0070DD"..date("%Y.%m.%d %H:%M").."|r")
		msg = gsub(msg, "%[[Xx][Pp]%]", "|cffB6CA00"..format("%0.f", UnitXP("player")/((TPM_currentTime+RSD:AddedTime())/3600)).."|r")
		if self:RecentLevelSpeed() == L["[No Data]"] then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffF6ADC6"..L["[No Data]"].."|r")
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffB6CA00"..format("%.2f",self:RecentLevelSpeed()/3600).."|r")
		end
		if player.level > 1 then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "|cffB6CA00"..format("%.2f",(TPM_totalTime+self:AddedTime())/(3600*(player.level-1))).."|r")
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "|cffF6ADC6"..L["[No Data]"].."|r")
		end
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%]", "|cffFF0000"..char.stats.kills.."|r")
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%+%]", "|cffFF0000"..self:AchievementStatistics("kills").."|r")
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%]", "|cffFF0000"..char.stats.deaths.."|r")
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%+%]", "|cffFF0000"..self:AchievementStatistics("deaths").."|r")
		msg = gsub(msg, "%[[Qq][Uu][Ee][Ss][Tt][Ss]%]", "|cff58ACFA"..self:AchievementStatistics("quests").."|r")
		if GetRealZoneText() then
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cff58ACFA"..GetRealZoneText().."|r") -- not sure if its too early or already avaiable at this point
		else
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cffF6ADC6[No Zone Info]|r")
		end
		if IsInGuild() and GetGuildInfo("player") then
			msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "|cffADFF2F"..GetGuildInfo("player").."|r")
		else
			msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "|cffF6ADC6[No Guild]|r")
		end
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", "|cffADFF2F"..player.name.."|r")
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", "|cffADFF2F"..player.class.."|r")
		msg = gsub(msg, "%[[Rr][Aa][Cc][Ee]%]", "|cffADFF2F"..player.race.."|r")
		msg = gsub(msg, "%[[Ff][Aa][Cc][Tt][Ii][Oo][Nn]%]", "|cffADFF2F"..player.faction.."|r")
		msg = gsub(msg, "%[[Rr][Ee][Aa][Ll][Mm]%]", "|cffADFF2F"..player.realm.."|r")
		for i = 1, 8 do
			msg = gsub(msg, "%{[Rr][Tt]"..i.."%}", "|T"..RT..i..":12|t")
		end
		msg = gsub(msg, "%{[Xx]%}", "|T"..RT.."7:12|t")
		msg = gsub(msg, "%{[Ss][Tt][Aa][Rr]%}", "|T"..RT.."1:12|t")
		msg = gsub(msg, "%{[Cc][Ii][Rr][Cc][Ll][Ee]%}", "|T"..RT.."2:12|t")
		msg = gsub(msg, "%{[Dd][Ii][Aa][Mm][Oo][Nn][Dd]%}", "|T"..RT.."3:12|t")
		msg = gsub(msg, "%{[Tt][Rr][Ii][Aa][Nn][Gg][Ll][Ee]%}", "|T"..RT.."4:12|t")
		msg = gsub(msg, "%{[Mm][Oo][Oo][Nn]%}", "|T"..RT.."5:12|t")
		msg = gsub(msg, "%{[Ss][Qq][Uu][Aa][Rr][Ee]%}", "|T"..RT.."6:12|t")
		msg = gsub(msg, "%{[Cc][Rr][Oo][Ss][Ss]%}", "|T"..RT.."7:12|t")
		msg = gsub(msg, "%{[Ss][Kk][Uu][Ll][Ll]%}", "|T"..RT.."8:12|t")
	else
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", player.level-1)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", player.level)
		msg = gsub(msg, "%[[Rr][Ee][Mm]%]", player.maxLevel - player.level)
		msg = gsub(msg, "%[[Mm][Aa][Xx]]", player.maxLevel)
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", self:TimetoString(char.levelTimeList[player.level]))
		msg = gsub(msg, "%[[Tt][Oo][Tt][Aa][Ll]%]", self:TimetoString(char.totalTimeList[player.level]))
		msg = gsub(msg, "%[[Dd][Ii][Ff][Ff]%]", self:TimeDiff())
		msg = gsub(msg, "%[[Aa][Ff][Kk]%]", self:TimetoString(char.stats.timeAFK))
		msg = gsub(msg, "%[[Aa][Ff][Kk]%+%]", self:TimetoString(char.stats.totalAFK))
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]%]", date("%m/%d/%y %H:%M"))
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]2%]", date("%Y.%m.%d %H:%M"))
		msg = gsub(msg, "%[[Xx][Pp]%]", char.experienceList[player.level])
		if self:RecentLevelSpeed() == L["[No Data]"] then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", L["[No Data]"])
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", format("%.2f",self:RecentLevelSpeed()/3600))
		end
		if player.level > 1 then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", format("%.2f",(TPM_totalTime+self:AddedTime())/(3600*(player.level-1))))
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", L["[No Data]"])
		end
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%]", char.stats.kills)
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%+%]", self:AchievementStatistics("kills"))
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%]", char.stats.deaths)
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%+%]", self:AchievementStatistics("deaths"))
		msg = gsub(msg, "%[[Qq][Uu][Ee][Ss][Tt][Ss]%]", self:AchievementStatistics("quests"))
		msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", GetRealZoneText())
		msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", select(1, GetGuildInfo("player")) or "[No Guild]")
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", player.name)
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", player.class)
		msg = gsub(msg, "%[[Rr][Aa][Cc][Ee]%]", player.race)
		msg = gsub(msg, "%[[Ff][Aa][Cc][Tt][Ii][Oo][Nn]%]", player.faction)
		msg = gsub(msg, "%[[Rr][Ee][Aa][Ll][Mm]%]", player.realm)
	end
	return msg
end

function RSD:ReplaceTextI(msg, subZone, isExample)
	local gsub = gsub	

	if isExample then
		local a = select(2, IsInInstance())
		msg = gsub(msg, "%[[Ii][Nn][Ss][Tt][Aa][Nn][Cc][Ee]%]", a == "party" and "|cffA8A8FF"..GetRealZoneText().."|r" or "|cffA8A8FFDeadmines|r")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", a == "party" and "|cff71D5FF"..(self:TimetoString(time() - timeInstance)).."|r" or "|cff71D5FF"..self:TimetoString(1500).."|r")
		msg = gsub(msg, "%[[Ss][Tt][Aa][Rr][Tt]%]", a == "party" and "|cffF6ADC6"..(timeInstanceStart or 0).."|r" or "|cffF6ADC614:27|r")
		msg = gsub(msg, "%[[Ee][Nn][Dd]%]", a == "party" and "|cffADFF2F"..date("%H:%M").."|r" or "|cffADFF2F14:52|r")
	else
		if subZone then subZone = ": "..subZone else subZone = "" end
		msg = gsub(msg, "%[[Ii][Nn][Ss][Tt][Aa][Nn][Cc][Ee]%]", GetRealZoneText()..subZone)
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", self:TimetoString(time() - timeInstance))
		msg = gsub(msg, "%[[Ss][Tt][Aa][Rr][Tt]%]", timeInstanceStart)
		msg = gsub(msg, "%[[Ee][Nn][Dd]%]", timeInstanceEnd)
	end
	return msg
end

function RSD:ReplaceTextG(msg, isExample, name, level, class, rank, zone, time, levelSpeed, classColor)
	local gsub = gsub

	if isExample then
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", "|cff"..GetClassColor(classColor).."|Hplayer:"..name.."|h"..name.."|h|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", "|cffF6ADC6"..level-1 .."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", "|cffADFF2F"..level.."|r")
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", "|cff71D5FF"..class.."|r")
		msg = gsub(msg, "%[[Rr][Aa][Nn][Kk]%]", "|cffADFF2F"..rank.."|r")
		if zone then -- guild member's zone sometimes is nil
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cffF6ADC6"..zone.."|r")
		else
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "")
		end
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", "|cff71D5FF"..time.."|r")
		msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffB6CA00"..levelSpeed.."|r")
	else
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", name)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", level-1)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", level)
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", class)
		msg = gsub(msg, "%[[Rr][Aa][Nn][Kk]%]", rank)
		msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", zone or "")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", time)
		msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", levelSpeed)
	end
	return msg
end

	-----------------------------
	--- 05  OnEvent Functions ---
	-----------------------------

function RSD:PLAYER_LEVEL_UP(_, level)
	-- update here, since UnitLevel("player") does not yet return the new value
	player.level = level
	playerDinged = true
	RequestTimePlayed() -- call TIME_PLAYED_MSG (event)

	-- update levelCounter; reset if leveled 19+ times
	if not char.levelCounter or char.levelCounter >= 19 then
		char.levelCounter = 0
	end
	char.levelCounter = char.levelCounter + 1
end

function RSD:TIME_PLAYED_MSG(_, ...)
--	want these event variables to be file-local scope -> using vararg (...)
	TPM_totalTime, TPM_currentTime = ...
	lastPlayedRequest = time()

	if playerDinged then
		playerDinged = false

		local a = char.totalTimeList[player.level-1]
		if a then
			-- TotalTime @ Ding - TotalTime @ previous Ding
			levelTime = TPM_totalTime - a
		else
			-- if no data for previous level, fall back to less accurate data
			-- this only gets refreshed when /played fires
			-- Last undinged LevelTime + (dinged TotalTime - last undinged TotalTime)
			levelTime = TPM_currentTime2 + (TPM_totalTime-TPM_totalTime2)
		end

		-- save player data to arrays
		local level = player.level
		char.levelTimeList[level] = levelTime
		char.totalTimeList[level] = TPM_totalTime
		char.experienceList[level] = tonumber(format("%0.f", player.XPMax/(levelTime/3600)))
		char.unixTimeList[level] = time()
		char.dateStampList[level] = date("%Y.%m.%d %H:%M:%S")
		if char.unixTimeList[level-1] then
			char.activityList[level] = tonumber(format("%.0f", (levelTime/(time()-char.unixTimeList[level-1]))*100))
		end

		-- play custom sound if the user supplied one, otherwise it will silently fail
		PlaySoundFile(profile.customSound, "Master")

		local text = self:ReplaceText(profile.dingMessage[profile.randomMessage and random(2, 6) or 1])
		instanceType = select(2, IsInInstance())
	--	Announce Ding Message
		if profile.normalAnnounce then
			-- announce to /say instead when soloing instance
			local msgType
			if instanceType == "none" or instanceType == "party" then
				msgType = GetNumPartyMembers() > 0 and "PARTY" or "SAY"
			elseif instanceType == "raid" then
				msgType = "RAID"
			elseif instanceType == "pvp" then
				msgType = "BATTLEGROUND"
			end
			
			self:ScheduleTimer(function() SCM(text, msgType) end, profile.announceDelay)
		else
			self:OutputFrame(text)
		end

	--	Zone Announce
		if profile.zoneAnnounce then
			local a = {GetChannelList()}
			for i = 1, 10 do
			--	the General channel could possibly have any channel number assigned 
				if a[i*2] == GENERAL then
					self:ScheduleTimer(function() SCM(text, "CHANNEL", nil, i*2-1) end, profile.announceDelay)
				end
			end
		end

	--	Guild Announce
		if profile.guildAnnounce and IsInGuild() then
			self:ScheduleTimer(function() SCM(text, "GUILD") end, profile.announceDelay)
		end
		
	--	Real ID Broadcast
		if profile.BNetBroadcast then
			-- save current Real ID Broadcast message
			self:ScheduleTimer(function()
				local broadcastMsg = select(3, BNGetInfo())
				BNSetCustomMessage(text)
				BNSetCustomMessage(broadcastMsg)
			end, profile.announceDelay)
		end

	--	Screenshot
		if profile.Screenshot then
		--	Hide UI (+ optional delay) to show the LevelUp animation
			local timeHideUI = profile.screenshotDelay-1
			if timeHideUI < 0 then timeHideUI = 0 end -- change any negative value to zero
		--	get original alpha for some reason its always a bit different than the set value e.g. 0.9 -> 0.988... 0.5 -> 0.498...
			local originalAlpha = UIParent:GetAlpha()
		--	got problems with timing hiding and showing UI again,
		--	so trying to Hide()/SetAlpha(0) 1 sec before screenshot
			if profile.screenshotHideUI then
				self:ScheduleTimer(function() UIParent:SetAlpha(0) end, timeHideUI)
			end
			self:ScheduleTimer(function() Screenshot() end, profile.screenshotDelay)
			if profile.screenshotHideUI then
				self:ScheduleTimer(function() UIParent:SetAlpha(originalAlpha) end, profile.screenshotDelay+1)
			end
		end

		-- reset [KILLS], [DEATHS], [AFK]
		char.stats.kills, char.stats.deaths, char.stats.timeAFK = 0, 0, 0

		-- update level summary
		self:LevelSummary()
	end

	-- update/prepare stuff for next levelup
	TPM_totalTime2, TPM_currentTime2 = TPM_totalTime, TPM_currentTime
	player.XPMax = UnitXPMax("player")
	self:NotifyChange()
end

function RSD:GUILD_ROSTER_UPDATE()

-- check all guild members (including offlines)
-- this is to avoid conflicts with other addons that change SetGuildRosterShowOffline(), and for level change diffs
	for i = 1, GetNumGuildMembers() do
		local name, rank, _, level, class, zone, _, _, _, _, classFileName = GetGuildRosterInfo(i)

		-- sanity check: in rare cases GetGuildRosterInfo() returns only a nil
		-- although I kinda think that realm[nil] would evaluate to a nil anyway ..
		if name and realm[name] then
			-- save (last 3 levels) level speed to [0] key
			for j = 3, 1, -1 do
				-- ignore the [0] and [1] key values
				if realm[name][level-j] and level-j ~= 1 and level-j ~= 0 then
					realm[name][0] = (time()-realm[name][level-j][1]) / (3600*j)
					break
				else
					-- no up to date data (or not anymore)
					realm[name][0] = nil
				end
			end

		--	level changed
			if profile.GuildMemberDings and level > realm[name][1] and name ~= player.name then
				-- online check (1 minute grace period for updating/logging in)
				if time() > timeLogin + 60 then
					local levelTimeG, levelSpeedG = "", ""
				
				--	level time; ignore the [1] key value
					if level-1 ~= 1 and type(realm[name][level-1]) == "table" then
						levelTimeG = " in "..self:TimetoString(time() - realm[name][level-1][1])
					end

				--	level speed
					if realm[name][0] then
						levelSpeedG = " ("..format("%.2f", 1/realm[name][0]).." "..HOUR.."/"..LEVEL..")"
					end

				--	level filters
					if level >= profile.guildMemberLevelFilter and (not guildMemberAchievementFilter or (guildMemberAchievementFilter and mod(level, 10) > 0 and level ~= 85)) then
						if profile.guildMemberAnnounce then
							SCM(self:ReplaceTextG(profile.guildMemberMsg, false, name, level, class, rank, zone, levelTimeG, levelSpeedG), "GUILD")
						else
							self:OutputFrame(self:ReplaceTextG(profile.guildMemberMsg, true, name, level, class, rank, zone, levelTimeG, levelSpeedG, classFileName))
						end
					end
				--	save time & date of levelup
					realm[name][level] = {}
					realm[name][level][1] = time()
					realm[name][level][2] = date("%Y.%m.%d %H:%M:%S")
				else
				--	level changed while user was offline
					realm[name][level] = false -- don't got time & date
					if not showedDiffs and char.lastCheck then
						showedDiffs = true
						print("RSD: |cffF6ADC6["..char.lastCheck.."]|r - |cffADFF2F["..date("%Y.%m.%d %H:%M").."]|r")
					end
					print("RSD: |cff"..GetClassColor(classFileName).."|Hplayer:"..name.."|h["..name.."]|h|r "..LEVEL.." |cffF6ADC6"..realm[name][1].."|r - |cffADFF2F"..level.."|r (+|cff71D5FF"..level-realm[name][1].."|r)")
				end
			end
		end
		-- define guildmember / update level to [1] key
		realm[name] = realm[name] or {}
		realm[name][1] = level
	end
end

function RSD:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, arg3, sourceName, arg5, destGUID, destName, arg8, ...)
	-- patch 4.1.0 backwards compatible fix; perform a tail call
	-- shift the 4th to 8th arguments 1 position to the left; arg5 -> arg4 (sourceName), arg8 -> arg7 (destName)
	if type(arg3) == "boolean" then
		return self:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, sourceName, arg5, destGUID, destName, arg8, ...)
	end
	local _, spellName, _, _, SuffixParam2 = ...

	local Time = time()
	local destType = strsub(destGUID, 5, 5)

	-- refresh instanceType and realZone
	if Time > (cd.zone or 0) then
		cd.zone = Time + 10
		realZone = GetRealZoneText()
		instanceType = select(2, IsInInstance())
	end

	-- [Deaths]
	if event == "UNIT_DIED" and destName == player.name then
		char.stats.deaths = char.stats.deaths + 1
	end

	-- [KILLS]
	if sourceName == player.name then
		if ((event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" or event == "RANGE_DAMAGE") and SuffixParam2 > 0) or (event == "SWING_DAMAGE" and spellName > 0) and Time > (cd.PlayerKill or 0) then
			cd.PlayerKill = Time + 0.5
			char.stats.kills = char.stats.kills + 1
		end
	end

-- Instance Timer
	-- LFG_COMPLETION_REWARD (event) would be a suitable alternative, but the drawback is that it only works when queued for random dungeons
	if event == "UNIT_DIED" and profile.instanceTimer and instanceType == "party" and (timeInstance > 0 or timeInstance2 > 0) then
		local destNPC = tonumber(strsub(destGUID, 7, 10), 16)

		for _, v in pairs(BossIDs) do
			if v == destNPC then
				timeInstanceEnd = date("%H:%M")

				-- "Scarlet Monastery"
				if destNPC == 4543 then self:InstanceAnnounce("Graveyard") -- [27-37?] Bloodmage Thalnos
				elseif destNPC == 6487 then self:InstanceAnnounce("Library") -- [30-40?] Arcanist Doan
				elseif destNPC == 3975 then self:InstanceAnnounce("Armory") -- [32-42?] Herod
				elseif destNPC == 3977 then self:InstanceAnnounce("Cathedral") -- [35-45] High Inquisitor Whitemane

				-- "Maraudon"
				elseif destNPC == 12236 then self:InstanceAnnounce("The Wicked Grotto"); timeInstance2 = timeInstance -- [39-49?] Lord Vyletongue
				elseif destNPC == 12258 then self:InstanceAnnounce("Foulspore Cavern"); timeInstance2 = timeInstance -- [41-51?] Razorlash
				elseif destNPC == 12201 then
					if timeInstance2 > 0 then timeInstance = timeInstance2 end
					self:InstanceAnnounce("Earth Song Falls") -- [34-44] Princess Theradras

				-- "Blackrock Depths"
				elseif destNPC == 9018 then self:InstanceAnnounce("Detention Block"); timeInstance2 = timeInstance -- [47-57] High Interrogator Gerstahn
				elseif destNPC == 9019 then
					if timeInstance2 > 0 then timeInstance = timeInstance2 end
					self:InstanceAnnounce("Upper City") -- [51-61] Emperor Dagran Thaurissan

				-- "Dire Maul"
				elseif destNPC == 11492 then self:InstanceAnnounce("Warpwood Quarter") -- [36-46] Alzzin the Wildshaper
				elseif destNPC == 11486 then self:InstanceAnnounce("Capital Gardens") -- [39-49] Prince Tortheldrin
				elseif destNPC == 11501 then self:InstanceAnnounce("Gordok Commons") -- [42-52] King Gordok

				-- "Stratholme"
				elseif destNPC == 10813 then self:InstanceAnnounce("Main Gate"); timeInstance2 = timeInstance -- [42-52] Balnazzar
				elseif destNPC == 45412 then
					if timeInstance2 > 0 then timeInstance = timeInstance2 end
					self:InstanceAnnounce("Service Entrance") -- [46-56] Lord Aurius Rivendare

				else
					-- Cookie (Normal Deadmines)
					if not (destNPC == 47739 and player.level < 85) then
						self:InstanceAnnounce()
					end
				end

				self:RecordInstance(subZone)
				-- reset "timers"
				timeInstance, timeInstance2 = 0, 0
				timeInstanceStart, timeInstanceStart2, timeInstanceEnd = "", "", ""
				break
			end
		end
	end
end

function RSD:CHAT_MSG_CHANNEL_NOTICE(_, msg)
	if msg == "YOU_CHANGED" then
		-- reset timer if it's 2 hours since last time player entered instance
		if select(2, IsInInstance()) == "party" and (timeInstance == 0 or time() > timeInstance + 7200) then
			timeInstance, timeInstanceStart, timeInstanceStart2 = time(), date("%H:%M"), date("%Y.%m.%d |cffF6ADC6[%H:%M]|r")
		end
	end
end

function RSD:LFG_PROPOSAL_SUCCEEDED()
	self:ScheduleTimer(function()
		-- backup timer (30 sec) for if timeInstance still is nil
		if timeInstance == 0 then
			timeInstance, timeInstanceStart, timeInstanceStart2 = time(), date("%H:%M"), date("%Y.%m.%d |cffF6ADC6[%H:%M]|r")
		end
	end, 30)
end

-- Instance Timer for "special" boss deaths (not localized)
function RSD:CHAT_MSG_MONSTER_YELL(_, msg)
	if profile.instanceTimer and instanceType == "party" and timeInstance > 0 then
		if msg == "No! I can do... better! I can..." or -- "Utgarde Keep" (Boss dies twice)
		msg == "Your journey has just begun, young prince. Gather your forces and meet me in the arctic land of Northrend. It is there that we shall settle the score between us. It is there that your true destiny will unfold." or -- "The Culling of Stratholme" (no death)
		msg == "No! I must not fail... again..." or -- "Trial of the Champion" (Boss dies x3)
		msg == "FIRE! FIRE!" then -- "Halls of Reflection" (invinceable; Escape Event)
			timeInstanceEnd = date("%H:%M")
			self:InstanceAnnounce()
			-- reset variables
			timeInstance, timeInstanceStart, timeInstanceStart2, timeInstanceEnd = 0, "", "", ""
		end
	end
end

--# Auto Gratz events
-- dont alt+tab with auto gratz on, it will spam all "queued" dings once you alt+tab back in
-- rather than checking for different names, just a global cooldown/throttle, since I suspect it would be abused fairly much
function RSD:CHAT_MSG_PARTY(_, msg, name)
	if profile.AutoGratz and name ~= player.name and strfind(msg, "[Dd][Ii][Nn][Gg]") and strlen(msg) <= 10 and time() > (cd.autoGratzParty or 0) then
		cd.autoGratzParty = time() + profile.autoGratzCooldown		
		self:AutoGratz("PARTY", name)
	end
end

function RSD:CHAT_MSG_GUILD(_, msg, name)
	if profile.AutoGratz and name ~= player.name and strfind(msg, "[Dd][Ii][Nn][Gg]") and strlen(msg) <= 10 and time() > (cd.autoGratzGuild or 0) then
		cd.autoGratzGuild = time() + profile.autoGratzCooldown
		self:AutoGratz("GUILD", name)
	end
end

function RSD:CHAT_MSG_GUILD_ACHIEVEMENT(_, msg, name)
	if profile.AutoGratz and name ~= player.name and ((not profile.gratzAllAchievements and strfind(msg, LEVEL)) or profile.gratzAllAchievements) and time() > (cd.autoGratzGuild or 0) then
		cd.autoGratzGuild = time() + profile.autoGratzCooldown
		self:AutoGratz("GUILD", name)
	end
end

function RSD:CHAT_MSG_SYSTEM(_, msg)
	if msg == MARKED_AFK or msg == MARKED_AFK_MESSAGE then
		timeAFK1 = time()
	end
	if msg == CLEARED_AFK and timeAFK1 then
		TimeAFK()
	end
	-- reset Instance Timer if left or kicked from group
	if msg == ERR_LEFT_GROUP_YOU or msg == ERR_UNINVITE_YOU then
		timeInstance = 0
	end
end

function RSD:PLAYER_LEAVING_WORLD() -- update [AFK], [AFK+]
	if UnitIsAFK("player") and timeAFK1 then
		TimeAFK()
	end
	-- time/date at logout for showing levelDiffs..
	char.lastCheck = date("%Y.%m.%d %H:%M")
end